org.gradle.tooling

## Interface ModelBuilder<T>

- Type Parameters:
    `T` - The type of model to build
  All Superinterfaces:
    LongRunningOperation

      public interface ModelBuilder<T>
      extends LongRunningOperation

  A `ModelBuilder` allows you to fetch a snapshot of some model for a project or a build. Instances of `ModelBuilder` are not thread-safe.

  You use a `ModelBuilder` as follows:

  - Create an instance of `ModelBuilder` by calling `ProjectConnection.model(Class)`.
  - Configure the builder as appropriate.
  - Call either `get()` or `get(ResultHandler)` to build the model.
  - Optionally, you can reuse the builder to build the model multiple times.
  Example:

       ProjectConnection connection = GradleConnector.newConnector()
          .forProjectDirectory(new File("someFolder"))
          .connect();

       try {
          ModelBuilder<GradleProject> builder = connection.model(GradleProject.class);

          //if you use a different than usual build file name:
          builder.withArguments("--build-file", "theBuild.gradle");

          //configure the standard input in case your build is interactive:
          builder.setStandardInput(new ByteArrayInputStream("consume this!".getBytes()));

          //if you want to listen to the progress events:
          ProgressListener listener = null; // use your implementation
          builder.addProgressListener(listener);

          //get the model:
          GradleProject project = builder.get();

          //query the model for information:
          System.out.println("Available tasks: " + project.getTasks());
       } finally {
          connection.close();
       }

  Since:
    1.0-milestone-3

- - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `ModelBuilder<T>` | `addProgressListener(ProgressListener listener)` Adds a progress listener which will receive progress events as the operation runs.
    `ModelBuilder<T>` | `forTasks(String... tasks)` Specifies the tasks to execute before building the model.
    `T` | `get()` Fetch the model, blocking until it is available.
    `void` | `get(ResultHandler<? super T> handler)` Starts fetching the model, passing the result to the given handler when complete.
    `ModelBuilder<T>` | `setJavaHome(File javaHome)` Specifies the Java home directory to use for this operation.
    `ModelBuilder<T>` | `setJvmArguments(String... jvmArguments)` Specifies the Java VM arguments to use for this operation.
    `ModelBuilder<T>` | `setStandardError(OutputStream outputStream)` Sets the `OutputStream` which should receive standard error logging generated while running the operation.
    `ModelBuilder<T>` | `setStandardInput(InputStream inputStream)` Sets the `InputStream` that will be used as standard input for this operation.
    `ModelBuilder<T>` | `setStandardOutput(OutputStream outputStream)` Sets the `OutputStream` which should receive standard output logging generated while running the operation.
    `ModelBuilder<T>` | `withArguments(String... arguments)` Specify the command line build arguments.

    - ### Methods inherited from interface org.gradle.tooling.LongRunningOperation

      `withCancellationToken`

- - ### Method Detail

    - #### withArguments

          ModelBuilder<T> withArguments(String... arguments)

      Specify the command line build arguments. Useful mostly for running tasks via `BuildLauncher`.

      Be aware that not all of the Gradle command line options are supported! Only the build arguments that configure the build execution are supported. They are modelled in the Gradle API via `StartParameter`. Examples of supported build arguments: '--info', '-u', '-p'. The command line instructions that are actually separate commands (like '-?' and '-v') are not supported. Some other instructions like '--daemon' are also not supported - the tooling API always runs with the daemon.

      If an unknown or unsupported command line option is specified, `UnsupportedBuildArgumentException` will be thrown at the time the operation is executed via `BuildLauncher.run()` or `get()`.

      For the list of all Gradle command line options please refer to the user guide or take a look at the output of the 'gradle -?' command. Majority of arguments modeled by `StartParameter` are supported.

      The arguments can potentially override some other settings you have configured. For example, the project directory or Gradle user home directory that are configured in the `GradleConnector`. Also, the task names configured by `BuildLauncher.forTasks(String...)` can be overridden if you happen to specify other tasks via the build arguments.

      See the example in the docs for `BuildLauncher`

      Specified by:
        `withArguments` in interface `LongRunningOperation`
      Parameters:
        `arguments` - Gradle command line arguments
      Returns:
        this
      Since:
        1.0

    - #### setStandardOutput

          ModelBuilder<T> setStandardOutput(OutputStream outputStream)

      Sets the `OutputStream` which should receive standard output logging generated while running the operation. The default is to discard the output.
      Specified by:
        `setStandardOutput` in interface `LongRunningOperation`
      Parameters:
        `outputStream` - The output stream. The system default character encoding will be used to encode characters written to this stream.
      Returns:
        this
      Since:
        1.0-milestone-3

    - #### setStandardError

          ModelBuilder<T> setStandardError(OutputStream outputStream)

      Sets the `OutputStream` which should receive standard error logging generated while running the operation. The default is to discard the output.
      Specified by:
        `setStandardError` in interface `LongRunningOperation`
      Parameters:
        `outputStream` - The output stream. The system default character encoding will be used to encode characters written to this stream.
      Returns:
        this
      Since:
        1.0-milestone-3

    - #### setStandardInput

          ModelBuilder<T> setStandardInput(InputStream inputStream)

      Sets the `InputStream` that will be used as standard input for this operation. Defaults to an empty input stream.

      If the target Gradle version does not support it the long running operation will fail with `UnsupportedOperationConfigurationException` when the operation is started.

      Specified by:
        `setStandardInput` in interface `LongRunningOperation`
      Parameters:
        `inputStream` - The input stream
      Returns:
        this
      Since:
        1.0-milestone-7

    - #### setJavaHome

          ModelBuilder<T> setJavaHome(File javaHome)

      Specifies the Java home directory to use for this operation.

      If the target Gradle version does not support it the long running operation will fail eagerly with `UnsupportedOperationConfigurationException` when the operation is started.

      `BuildEnvironment` model contains information such as Java or Gradle environment. If you want to get hold of this information you can ask tooling API to build this model.

      If not configured or null passed the sensible default will be used.

      Specified by:
        `setJavaHome` in interface `LongRunningOperation`
      Parameters:
        `javaHome` - to use for the Gradle process
      Returns:
        this
      Since:
        1.0-milestone-8

    - #### setJvmArguments

          ModelBuilder<T> setJvmArguments(String... jvmArguments)

      Specifies the Java VM arguments to use for this operation.

      If the target Gradle version does not support it the long running operation will fail eagerly with `UnsupportedOperationConfigurationException` when the operation is started.

      `BuildEnvironment` model contains information such as Java or Gradle environment. If you want to get hold of this information you can ask tooling API to build this model.

      If not configured, null an empty array passed then the reasonable default will be used.

      Specified by:
        `setJvmArguments` in interface `LongRunningOperation`
      Parameters:
        `jvmArguments` - to use for the Gradle process
      Returns:
        this
      Since:
        1.0-milestone-9

    - #### addProgressListener

          ModelBuilder<T> addProgressListener(ProgressListener listener)

      Adds a progress listener which will receive progress events as the operation runs.
      Specified by:
        `addProgressListener` in interface `LongRunningOperation`
      Parameters:
        `listener` - The listener
      Returns:
        this
      Since:
        1.0-milestone-3

    - #### forTasks

          @Incubating
          ModelBuilder<T> forTasks(String... tasks)

      Specifies the tasks to execute before building the model. By default, no tasks are executed.
      Parameters:
        `tasks` - The paths of the tasks to be executed. Relative paths are evaluated relative to the project for which this launcher was created.
      Returns:
        this
      Since:
        1.2

    - #### get

          T get()
                throws GradleConnectionException,
                       IllegalStateException

      Fetch the model, blocking until it is available.
      Returns:
        The model.
      Throws:
        `UnsupportedVersionException` - When the target Gradle version does not support building models.
        `UnknownModelException` - When the target Gradle version or build does not support the requested model.
        `UnsupportedOperationConfigurationException` - When the target Gradle version does not support some requested configuration option such as `setStandardInput(java.io.InputStream)`, `setJavaHome(java.io.File)`, `setJvmArguments(String...)`.
        `UnsupportedBuildArgumentException` - When there is a problem with build arguments provided by `withArguments(String...)`.
        `BuildException` - On some failure executing the Gradle build.
        `BuildCancelledException` - When the operation was cancelled before it completed successfully.
        `GradleConnectionException` - On some other failure using the connection.
        `IllegalStateException` - When the connection has been closed or is closing.
      Since:
        1.0-milestone-3

    - #### get

          void get(ResultHandler<? super T> handler)
                   throws IllegalStateException

      Starts fetching the model, passing the result to the given handler when complete. This method returns immediately, and the result is later passed to the given handler's `ResultHandler.onComplete(Object)` method.

      If the operation fails, the handler's `ResultHandler.onFailure(GradleConnectionException)` method is called with the appropriate exception. See `get()` for a description of the various exceptions that the operation may fail with.

      Parameters:
        `handler` - The handler to supply the result to.
      Throws:
        `IllegalStateException` - When the connection has been closed or is closing.
      Since:
        1.0-milestone-3